//More-Ausgabe  

void setup() {
  Serial.begin(9600);
}

void loop() {
  char text[] = "HALLO NANO   ";
  //char text[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ      ";
  char dot = 100;     //Punktlänge 100 ms für 60 Buchstaben pro Minute
  pinMode(0, OUTPUT); 
  int d[255];
  d[1] = 32;     
  d[2] = 69;     //"E",      . , 00000010, ASCII 69
  d[3] = 84;     //"T",      - , 00000011, ASCII 84
  d[4] = 73;     //"I",     .. , 00000100, ASCII 73
  d[5] = 65;     //"A",     .- , 00000101, ASCII 65
  d[6] = 78;     //"N",     -. , 00000110, ASCII 78
  d[7] = 77;     //"M",     -- , 00000111, ASCII 77
  d[8] = 83;     //"S",    ... , 00001000, ASCII 83
  d[9] = 85;     //"U",    ..- , 00001001, ASCII 85
  d[10] = 82;     //"R",    .-. , 00001010, ASCII 82
  d[11] = 87;     //"W",    .-- , 00001011, ASCII 87
  d[12] = 68;     //"d",    -.. , 00001100, ASCII 68
  d[13] = 75;     //"K",    -.- , 00001101, ASCII 75
  d[14] = 71;     //"G",    --. , 00001110, ASCII 71
  d[15] = 79;     //"O",    --- , 00001111, ASCII 79
  d[16] = 72;     //"H",   .... , 00010000, ASCII 72
  d[17] = 86;     //"V",   ...- , 00010001, ASCII 86
  d[18] = 70;     //"F",   ..-. , 00010010, ASCII 70
  d[19] = 32;
  d[20] = 76;     //"L",   .-.. , 00010100, ASCII 76
  d[21] = 32;
  d[22] = 80;     //"P",   .--. , 00010110, ASCII 80
  d[23] = 74;     //"J",   .--- , 00010111, ASCII 74
  d[24] = 66;     //"B",   -... , 00011000, ASCII 66
  d[25] = 88;     //"X",   -..- , 00011001, ASCII 88
  d[26] = 67;     //"C",   -.-. , 00011010, ASCII 67
  d[27] = 89;     //"Y",   -.-- , 00011011, ASCII 89
  d[28] = 90;     //"Z",   --.. , 00011100, ASCII 90
  d[29] = 81;     //"Q",   --.- , 00011101, ASCII 81
  d[30] = 32;
  d[31] = 32;
  d[32] = 53;     //"5",  ..... , 00100000, ASCII 53
  d[33] = 52;     //"4",  ....- , 00100001, ASCII 52
  d[34] = 32;
  d[35] = 51;     //"3",  ...-- , 00100011, ASCII 51
  d[36] = 32;
  d[37] = 32;
  d[38] = 32;
  d[39] = 50;     //"2",  ..--- , 00100111, ASCII 50
  d[40] = 32;
  d[41] = 32;
  d[42] = 32;
  d[43] = 32;
  d[44] = 32;
  d[45] = 32;
  d[46] = 32;
  d[47] = 49;     //"1",  .---- , 00101111, ASCII 49
  d[48] = 54;     //"6",  -.... , 00110000, ASCII 54
  d[49] = 32;
  d[50] = 32;
  d[51] = 32;
  d[52] = 32;
  d[53] = 32;
  d[54] = 32;
  d[55] = 32;
  d[56] = 55;     //"7",  --... , 00111000, ASCII 55
  d[57] = 32;
  d[58] = 32;
  d[59] = 32;
  d[60] = 56;     //"8",  ---.. , 00111100, ASCII 56
  d[61] = 32;
  d[62] = 57;     //"9",  ----. , 00111110, ASCII 57
  d[63] = 48;     //"0",  ----- , 00111111, ASCII 48

  for (int n=0; n< strlen(text); n++){  
    char c= text[n];    //Einzelne Zeichen abtrennen
    Serial.print(c);
    unsigned int m=0;
    for (int j=1; j<91; j++){
      if (d[j]==(unsigned int)c){
        m=j;           //Morsecode finden
        j=91;
      }
    }  
    //Serial.println(m);
    int start=0;
    int i=1;
    if(m==1) delay (3*dot);  //Leerzeichen-Pause
    while(m<128){       //Startbit finden
      i++;
      m=m*2;
    }
    while(i<8){
      m=m*2;
      i++;
      if (m&128){       //Strich
        analogWrite (9,100);
        delay (3*dot);
        analogWrite (9,0);
        delay(dot);  
      }
      else{             //Punkt
        analogWrite (9,100);
        delay (dot);
        analogWrite (9,0);
        delay(dot);  
      }
    }
    delay (3*dot);      //Pause zwischen Zeichen
  } 
}
